#ifndef __GM_UI_H__
#define __GM_UI_H__

#ifdef HAVE_CONFIG_H
#include "../config.h"
#endif

#include <gtk/gtk.h>
#include "widgets/gm-app-view.h"
#include "gm-support.h"

G_BEGIN_DECLS

static const GtkActionEntry gm_sensitive_menu_entries[] =
{
	/* Toplevel */
	{"World", NULL, N_("_World")},
	{"Edit", NULL, N_("_Edit")},
	{"View", NULL, N_("_View")},
	{"Help", NULL, N_("_Help")},

	/* World menu */
	{"WorldNew", GTK_STOCK_NEW, N_("New World..."), "<control>N",
			N_("Create a new world"), G_CALLBACK(on_gm_app_view_world_new)},
	{"WorldQuit", GTK_STOCK_QUIT, NULL, NULL,
			N_("Quit the program"), G_CALLBACK(on_gm_app_view_world_quit)},
	
	/* Edit menu */
	{"EditWorlds", NULL, N_("Worlds..."), "<control>L",
			N_("Edit worlds"), G_CALLBACK(on_gm_app_view_edit_worlds)},
	{"EditPreferences", GTK_STOCK_PREFERENCES, NULL, NULL,
			N_("Configure the application"), 
			G_CALLBACK(on_gm_app_view_edit_preferences)},
	
	/* View menu */
	{"ViewMcp", NULL, N_("MCP"), NULL,
			N_("View MCP console"), G_CALLBACK(on_gm_app_view_view_mcp)},
	{"ViewScripts", NULL, N_("Scripts"), NULL,
			N_("View scripts"), G_CALLBACK(on_gm_app_view_view_scripts)},

	/* Help menu */
	{"HelpAbout", GTK_STOCK_ABOUT, NULL, NULL,
			N_("About this application"), G_CALLBACK(on_gm_app_view_help_about)}
};

static const GtkActionEntry gm_menu_entries[] =
{
	/* File menu */
	{"WorldConnect", GTK_STOCK_NETWORK, N_("Connect"), "<control><shift>C",
			N_("Connect or disconnect the current world"), 
			G_CALLBACK(on_gm_app_view_world_connect)},
	{"WorldClose", GTK_STOCK_CLOSE, NULL, NULL,
			N_("Close current world"), G_CALLBACK(on_gm_app_view_world_close)},
	{"WorldLogs", GTK_STOCK_FILE, N_("Logs"), NULL,
			N_("View current world logs"), 
			G_CALLBACK(on_gm_app_view_world_logs)},
	{"WorldInfo", GTK_STOCK_INFO, N_("In_fo"), NULL,
			N_("View current world info"), NULL},

	/* Edit menu */
	{"EditCut", GTK_STOCK_CUT, NULL, "<control>X",
			N_("Cut the selection"), G_CALLBACK(on_gm_app_view_edit_cut)},
	{"EditCopy", GTK_STOCK_COPY, NULL, "<control>C",
			N_("Copy the selection"), G_CALLBACK(on_gm_app_view_edit_copy)},
	{"EditPaste", GTK_STOCK_PASTE, NULL, "<control>V",
			N_("Paste the clipboard"), G_CALLBACK(on_gm_app_view_edit_paste)},
	{"EditWorld", NULL, N_("Current world..."), "<control>E",
			N_("Edit the current world"), 
			G_CALLBACK(on_gm_app_view_edit_world)},
	{"EditFind", GTK_STOCK_FIND, NULL, "<control>F",
			N_("Find text"), G_CALLBACK(on_gm_app_view_edit_find)},
	{"EditFindNext", GTK_STOCK_FIND, N_("Find next"), "<control>G",
			N_("Find next occurence"), 
			G_CALLBACK(on_gm_app_view_edit_find_next)},
};

G_END_DECLS

#endif  /* __GEDIT_UI_H__  */
